\ $DEFINE DEBUG-ZX-TRACER

;; ////////////////////////////////////////////////////////////////////////// //
: (ZX-TRACE-CFA) ( cfa -- )
  TOZX

    \ ." ***tracing: " DUP UR-ZX-WORD-NAME-BY-CFA IFNOT " NOT FOUND!" UFE-FATAL ENDIF XTYPE CR


  ;; do not trace already traced word
  DUP UR-ZX-WORD-USED-BY-CFA? IF DROP EXIT ENDIF
    \ DUP UR-ZX-WORD-NAME-BY-CFA DROP ." !!! " XTYPE CR

  ;; set "traced" mark
  DUP UR-ZX-WORD-USED-BY-CFA-1!

  \ ."   used: " DUP UR-ZX-WORD-NAME-BY-CFA IFNOT " NOT FOUND!" UFE-FATAL ENDIF XTYPE CR

  ;; do not trace non-forth words
  DUP UR-ZX-WORD-TYPE-BY-CFA FWT-FORTH <> IF
    $IFDEF DEBUG-ZX-TRACER
      ." NOTFORTH: " DUP UR-ZX-WORD-NAME-BY-CFA IFNOT " NOT FOUND!" UFE-FATAL ENDIF XTYPE CR
    $ENDIF
    \ ."    NOTFORTH!\n"

    ;; special DEFERed words
    UR-ZX-WORD-NAME-BY-CFA IFNOT " NOT FOUND!" UFE-FATAL ENDIF
    ;; ( addr count )
    2DUP " EMIT" STR= IF
      " EMIT6" UR-ZX-FIND-WORD IF RECURSE ENDIF
      " EMIT8" UR-ZX-FIND-WORD IF RECURSE ENDIF
    ENDIF
    2DUP " XEMIT" STR= IF
      " XEMIT6" UR-ZX-FIND-WORD IF RECURSE ENDIF
      " XEMIT8" UR-ZX-FIND-WORD IF RECURSE ENDIF
    ENDIF
    2DUP " WHEREX" STR= IF
      " WHEREX6" UR-ZX-FIND-WORD IF RECURSE ENDIF
      " WHEREX8" UR-ZX-FIND-WORD IF RECURSE ENDIF
    ENDIF
    2DUP " WHEREY" STR= IF
      " WHEREY6" UR-ZX-FIND-WORD IF RECURSE ENDIF
      " WHEREY8" UR-ZX-FIND-WORD IF RECURSE ENDIF
    ENDIF
    2DUP " GOTOXY" STR= IF
      " GOTOXY6" UR-ZX-FIND-WORD IF RECURSE ENDIF
      " GOTOXY8" UR-ZX-FIND-WORD IF RECURSE ENDIF
    ENDIF
    2DUP " GOTOXY16" STR= IF
      " GOTOXY6_16" UR-ZX-FIND-WORD IF RECURSE ENDIF
      " GOTOXY8_16" UR-ZX-FIND-WORD IF RECURSE ENDIF
    ENDIF
    2DUP " WHEREXY16" STR= IF
      " WHERE6_16" UR-ZX-FIND-WORD IF RECURSE ENDIF
      " WHERE8_16" UR-ZX-FIND-WORD IF RECURSE ENDIF
    ENDIF

    2DROP
    EXIT
  ENDIF
    \ ." ...\n"
    \ DUP UR-ZX-WORD-TYPE-BY-CFA 3 SPACES . CR

  ;; move to PFA
  DUP >R


  $IFDEF DEBUG-ZX-TRACER
    ." **tracing: " DUP UR-ZX-WORD-NAME-BY-CFA IFNOT " NOT FOUND!" UFE-FATAL ENDIF XTYPE CR
  $ENDIF

  ;; to PFA
  3+

  ;; trace labels (this also determines word end)
  DP@ TO ZX-TRACER-SAVED-DP
  DUP ZX-TRACE-LABELS
  ZX-TRACER-SAVED-DP DP!
    \ ." traced\n"

  ZX-TRACER-WORD-END SWAP
  ;; ( endaddr pfa )
  BEGIN
    2DUP U>
  WHILE
    ;; ( endaddr pfa )
    DUP @ RECURSE
    ;; trace word compiled by (COMPILE) too
    DUP @ UR-ZX-WORD-FLAGS-BY-CFA FWF-COMPILE AND IF
      DUP 2+ @ RECURSE
    ENDIF
    ZX-TRACE-SKIP-INSTR
  REPEAT
  2DROP

  R>
  $IFDEF DEBUG-ZX-TRACER
    ." DONE tracing: " UR-ZX-WORD-NAME-BY-CFA IFNOT " NOT FOUND!" UFE-FATAL ENDIF XTYPE CR
  $ELSE
    DROP
  $ENDIF
;


;; ////////////////////////////////////////////////////////////////////////// //
: ZX-TRACE-ALLOWED?  ( -- flag )
  UR-PASS? 0= UR-AFTER-TRACE? 0= AND
;

: ZX-TRACE  ( -- )  \ wordname
  \ " ZX word tracer is broken for now" UFE-FATAL

  BL WORD COUNT UR-ZX-FIND-WORD IFNOT " NOT FOUND!" UFE-FATAL ENDIF
  ;; ( cfa )

  ZX-TRACE-ALLOWED? IFNOT
    ." tracing zx word: " DUP UR-ZX-WORD-NAME-BY-CFA IFNOT " NOT FOUND!" UFE-FATAL ENDIF XTYPE CR
    (ZX-TRACE-CFA)
  ELSE
    DROP
  ENDIF
;

: ZX-DECOMP ( -- )  \ wordname
  BL WORD COUNT UR-ZX-FIND-WORD IFNOT " NOT FOUND!" UFE-FATAL ENDIF
  ;; ( cfa )
  3+

  DP@ TO ZX-TRACER-SAVED-DP
  DUP ZX-TRACE-LABELS
  (ZX-DECOMP)
  ZX-TRACER-SAVED-DP DP!
;
